// AC 327 ms, 20MB
// https://codeforces.com/problemset/problem/427/C
#include <iostream>
#include <vector>
#include <stack>
#include <cstring>
using namespace std;
using ll = long long;

const int N  = 100010,
         MOD = 1000000007;

ll n, m;
ll money, ways, val[N];
bool v[N];
stack<ll> stk;
vector<ll> comp;        // comp t-c curenta
vector<ll> G[N];
vector<ll> Gt[N];

void Dfs(ll x)
{
    v[x] = true;
    for (int y : G[x])
    {
        if (v[y]) continue;
        Dfs(y);
    }
    stk.push(x);
}

void DfsT(ll x)
{
    v[x] = true;
    comp.push_back(x);
    for (int y : Gt[x])
    {
        if (v[y]) continue;
        DfsT(y);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> val[i];

    cin >> m;
    ll x, y;
    for(int i = 1; i <= m; ++i)
    {
        cin >> x >> y;
        G[x].push_back(y);
        Gt[y].push_back(x);
    }

    memset(v, 0, sizeof(v));

    /// Kosaraju pt ctc
    for (int i = 1; i <= n; ++i)
    {
        if (v[i]) continue;
        Dfs(i);
    }

    money = 0, ways = 1;
    memset(v, 0, sizeof(v));
    ll vmin = MOD, cnt = 0;
    while (!stk.empty())
    {
        int x = stk.top();
        stk.pop();
        if(v[x]) continue;
        comp.clear();
        DfsT(x);

        vmin = MOD;
        cnt = 0;
        for (int x : comp)
            vmin = min(vmin, val[x]);

        money += vmin;
        for (int x : comp)
            if (val[x] == vmin)
                cnt++;
        ways = (ways * cnt) % MOD;
    }

    cout << money << ' ' << ways;

}
